

*******************************
*Replication Files for Liu and Meissner
*Geography, Income, and Trade in the 21st Century
*Journal of Development Economics
*July 30, 2018
*Table of Contents
*1. Data setup-- Inequality data, prices from Feenstra and Romalis (Lines: 15-132)
*2. Gravity models: 2006, 1996, 2001, 2011 (construct MPs and provide results for Table 1, Lines: 137-2230)
*3. Panel Gravity models  (Table 1 columns 5 and 6) (Lines: 2235-2346)
*4. Data setup for wage equation regressions (Lines: 2358-2460) 
*5. Wage equation regressions (Tables 2-5, Figures 1-8) (Lines: 2465-2690)
*6. Folder cleanup 

*******************************

cd "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\JDE-Replication\"
set mem 800M

clear all

*Delete
*cd " ... "


*****most recent inequality data from UNU-wiid****
use "wiid_ver3_sept15.dta", clear

ren Countrycode3 iso3_o
ren Gini inequality
ren Year year

save inequality_wiid_2015.dta, replace


****price index from Feenstra*****
/*
*CODE INCLUDED FOR REFERENCE ONLY

*******************
*PRICES FOR 2006
*******************

use "Prices_and_quality_per_year_sitc4u_and_country_2006.dta", clear

rename iso3 iso_o
replace iso_o="ROM" if iso_o=="ROU"
keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

bysort iso_o: egen exports_total=total(exports)
gen exports_share=exports/exports_total
gen qa_price_exp_weight=qa_price_exp*exports_share
bysort iso_o: egen qa_price_exp_all=total(qa_price_exp_weight)
keep year iso_o qa_price_exp_all

duplicates drop

sort iso_o year
save price_ctry_2006.dta, replace


*******************
*PRICES FOR 1996
*******************

use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\price index from Feenstra\Prices_and_quality_per_year_sitc4u_and_country_1996.dta", clear


rename iso3 iso_o
replace iso_o="ROM" if iso_o=="ROU"
keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

bysort iso_o: egen exports_total=total(exports)
gen exports_share=exports/exports_total
gen qa_price_exp_weight=qa_price_exp*exports_share
bysort iso_o: egen qa_price_exp_all=total(qa_price_exp_weight)

keep year iso_o qa_price_exp_all

duplicates drop

sort iso_o year

save price_ctry_1996.dta, replace

*******************
*PRICES FOR 2001
*******************

use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\price index from Feenstra\Prices_and_quality_per_year_sitc4u_and_country_2001.dta", clear


rename iso3 iso_o
replace iso_o="ROM" if iso_o=="ROU"
keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

bysort iso_o: egen exports_total=total(exports)
gen exports_share=exports/exports_total
gen qa_price_exp_weight=qa_price_exp*exports_share
bysort iso_o: egen qa_price_exp_all=total(qa_price_exp_weight)

keep year iso_o qa_price_exp_all

duplicates drop

sort iso_o year

save price_ctry_2001.dta, replace

*******************
*PRICES FOR 2011
*******************

use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\price index from Feenstra\Prices_and_quality_per_year_sitc4u_and_country_2011.dta", clear


rename iso3 iso_o
replace iso_o="ROM" if iso_o=="ROU"
keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

bysort iso_o: egen exports_total=total(exports)
gen exports_share=exports/exports_total
gen qa_price_exp_weight=qa_price_exp*exports_share
bysort iso_o: egen qa_price_exp_all=total(qa_price_exp_weight)

keep year iso_o qa_price_exp_all

duplicates drop

sort iso_o year

save price_ctry_2011.dta, replace
*/


************************************************

**************GRAVITY FOR 2006******************

************************************************

*******************
*USES WIOD DATA 1995-2011
*Replication will rely on extract of these data-- N.B. WIOD is 337MB
*Users can download WIOD Release 2013 themselves to do a full replication
*http://www.wiod.org/home
********************

/*use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\wiot_stata_sep12\wiot_full.dta", clear


keep if year==2005 | year==2006 |year==2007
*Note rows above 35 are inputs, VA ,some taxes, and the sum of all = gross output.
*Columns are bu use: final, investment, intermediate...

keep if row_item<=35 
*Note sectors beyond 35 are redundant they include value added which are in the final use categories by construction.


bysort row_country col_country row_item col_item: egen value_mean=mean(value)

keep if year==2006


rename row_country iso_o
rename col_country iso_d
drop row_item col_item


bysort iso_o iso_d: egen tradeflow=total(value_mean)

keep iso_o iso_d year tradeflow  
drop if tradeflow<0
duplicates drop
replace iso_o="ROM" if iso_o=="ROU"
replace iso_d="ROM" if iso_d=="ROU"

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"



bysort iso_d: egen consumption_total_d=total(tradeflow)
bysort iso_o: egen production_total_o=total(tradeflow)


*Key variable for generating the dependendent variable for gravity
gen trade_share_wiod=tradeflow/consumption_total_d
keep iso_o iso_d year tradeflow trade_share_wiod consumption_total_d production_total_o
duplicates drop

sort iso_o iso_d year

save tradeflows_wiod.dta, replace
*/


********************
*Gravity SETUP
********************

use inequality_wiid_2015.dta, clear


bysort iso3_o year: egen gini=mean(inequality)

keep if year==2005|year==2006 |year==2007
bysort iso3_o: egen gini_m=mean(gini)

replace year=2006

keep iso3_o year gini_m
duplicates drop
set obs 123
replace iso3_o = "AUS" in 123
replace year = 2006 in 123
replace gini_m = 39.5 in 123
replace iso3_o="ROM" if iso3_o=="ROU"
rename iso3_o iso_o

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

sort iso_o 

save inequality_wiid_2015_o.dta, replace


use gravity_variables_cepii.dta, clear

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


sort iso_o
merge m:1 iso_o using inequality_wiid_2015_o.dta
tab _merge
keep if _merge==3
drop _merge

ren gini_m inequality_o

preserve

use inequality_wiid_2015_o.dta, clear
ren iso_o iso_d
sort iso_d year
save inequality_wiid_2015_d.dta, replace

restore
sort iso_d year

merge m:1 iso_d year using inequality_wiid_2015_d.dta

tab _merge
keep if _merge==3
drop _merge

rename gini_m inequality_d

save gravity_ineq_40.dta, replace


*******************************************

*Non-homothetic gravity with inequality
*2006
*******************************************

*Making the dyadic gravity data and merging in control variables
use penn_wt.dta, clear
keep if year==2006
sort iso_d year
save penn_wt_2006.dta, replace

use gravity_ineq_40.dta, clear

sort iso_o iso_d year
merge 1:1 iso_o iso_d year using tradeflows_wiod.dta
keep if _merge==3
drop _merge



sort iso_o year
merge iso_o year using price_ctry_2006.dta

tab _merge
keep if _merge==3
drop _merge


*Generate world expenditure
preserve 
keep iso_d consumption_total_d year
duplicates drop
bysort year: egen consumption_world=total(consumption_total_d)
keep year consumption_world  
duplicates drop 
sort year
save consumption_total.dta, replace


restore
sort year
merge m:1 year using consumption_total.dta
tab _merge
drop _merge

*Generate dependent variable for gravity
gen trade_share_adj_wiod=trade_share_wiod-production_total_o/consumption_world
gen share=production_total_o/consumption_world


preserve

use penn_wt.dta, clear
keep if year==2006
keep iso_d year pop cgdp
replace iso_d="DEU" if iso_d=="GER"
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


duplicates drop
sort iso_d year
save penn_wt_2006_d.dta, replace


use penn_wt.dta, clear
keep if year==2006
keep iso_d year pop cgdp
replace iso_d="DEU" if iso_d=="GER"
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"
rename iso_d iso_o
rename pop pop_o
rename cgdp gdp_pc_o
duplicates drop
sort iso_o year
save penn_wt_2006_o.dta, replace



restore
sort iso_d year
merge m:1 iso_d year using penn_wt_2006_d.dta
drop _merge
rename pop pop_d
rename cgdp gdp_pc_d

sort iso_o year
merge m:1 iso_o year using penn_wt_2006_o.dta
drop _merge


*Key controls for non-homotehtic gravity model
gen lnconsumption_pc_d=ln(consumption_total_d/pop_d)
gen lntrade_wiod=ln(tradeflow)
*Distance
gen lndist=ln(distw)
*Contiguity/shared border = 1
replace contig=1 if iso_o==iso_d
*Share a common official language = 1
replace comlang_off=1 if iso_o==iso_d

*Weighted trade cost terms
*See text for definitions
bysort iso_d year: egen dist_mean_d=mean(lndist)
gen dist_weighted=consumption_total_d/consumption_world*(lndist-dist_mean_d)
bysort iso_o year: egen lndist_mean_weighted_o=total(dist_weighted)
gen D_in=lndist-dist_mean_d-lndist_mean_weighted_o
gen d_in=lndist-dist_mean_d


gen nocontig=1-contig
bysort iso_d year: egen nocontig_mean_d=mean(nocontig)
gen nocontig_weighted=consumption_total_d/consumption_world*(nocontig-nocontig_mean_d)
bysort iso_o year: egen nocontig_mean_weighted_o=total(nocontig_weighted)
gen Nocontig_in=nocontig-nocontig_mean_d-nocontig_mean_weighted_o
gen nocontig_in=nocontig-nocontig_mean_d

gen nocomlang_off=1-comlang_off
bysort iso_d year: egen nocomlang_mean_d=mean(nocomlang_off)
gen nocomlang_weighted=consumption_total_d/consumption_world*(nocomlang_off-nocomlang_mean_d)
bysort iso_o year: egen nocomlang_mean_weighted_o=total(nocomlang_weighted)
gen Nocomlang_in=nocomlang_off-nocomlang_mean_d-nocomlang_mean_weighted_o
gen nocomlang_in=nocomlang_off-nocomlang_mean_d

encode iso_o, gen(ctry_o)
encode iso_d, gen(ctry_d)

*Term for adjusted non-homotehtic income
gen sigma=invnormal((inequality_d/100+1)/2)
gen theil_i=sigma^2
gen lngdp_cap_real=ln(gdp_pc_d)

*Price index
gen price_w=(ln(qa_price_exp_all)+0.177*lndist)*trade_share_wiod
bysort iso_d year: egen price_d=total(price_w)
replace price_d=. if price_d==0

*income per capita + inequality as required by model
gen omiga_i=lnconsumption_pc-price_d+theil_i

****Save omega_i for sectoral regression
preserve
keep iso_d omiga_i
duplicates drop
sort iso_d
save yn_2006.dta, replace
restore


*Weights x country level Omega - Used for weighted averages below
gen omiga_i_w=omiga_i*consumption_total_d/consumption_world


*These terms allow for calculation of domestic and foreign market potential
gen omiga_i_w_forg=omiga_i_w if iso_o!=iso_d
gen omiga_i_w_dom=omiga_i_w if iso_o==iso_d
bysort iso_o year: egen omiga_total_forg=total(omiga_i_w_forg)
bysort iso_o year: egen omiga_total_dom=total(omiga_i_w_dom)


gen dist_weighted_forg=dist_weighted if iso_o!=iso_d
gen dist_weighted_dom=dist_weighted  if iso_o==iso_d
bysort iso_o year: egen lndist_mean_weighted_forg_o=total(dist_weighted_forg)
bysort iso_o year: egen lndist_mean_weighted_dom_o=total(dist_weighted_dom)

gen nocomlang_weighted_forg=nocomlang_weighted if iso_o!=iso_d
gen nocomlang_weighted_dom=nocomlang_weighted  if iso_o==iso_d
bysort iso_o year: egen nocomlang_mean_weighted_forg_o=total(nocomlang_weighted_forg)
bysort iso_o year: egen nocomlang_mean_weighted_dom_o=total(nocomlang_weighted_dom)

gen nocontig_weighted_forg=nocontig_weighted if iso_o!=iso_d
gen nocontig_weighted_dom=nocontig_weighted if iso_o==iso_d
bysort iso_o year: egen nocontig_mean_weighted_forg_o=total(nocontig_weighted_forg)
bysort iso_o year: egen nocontig_mean_weighted_dom_o=total(nocontig_weighted_dom)



*For quadratic model
gen omiga_i_sq=omiga_i^2
gen omiga_i_sq_w=omiga_i_sq*consumption_total_d/consumption_world

preserve
keep iso_d year omiga_i_w omiga_i_sq_w
duplicates drop
bysort year: egen omiga_total=total(omiga_i_w)
bysort year: egen omiga_total_sq=total(omiga_i_sq_w)

keep year omiga_total omiga_total_sq


duplicates drop
sort year
save omiga_total.dta, replace

restore
sort year
merge m:1 year using omiga_total.dta

*Note Capitalized variables are differenced
gen Omiga_i=omiga_i-omiga_total
gen Omiga_i_sq=omiga_i_sq-omiga_total_sq


drop if trade_share_adj_wiod==. | D_in==. | omiga_i==.
egen exp_group=group(ctry_o)
egen imp_group=group(ctry_d)

sum exp_group

*Various indicators and interactions for estimation
forvalues i=1(1)40{
gen exp_`i'=0
replace exp_`i'=1 if exp_group==`i'

}

forvalues i=1(1)40{
gen imp_`i'=0
replace imp_`i'=1 if imp_group==`i'

}
forvalues i=1(1)40{
gen omiga_od`i'=Omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_i`i'=omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_od_`i'=omiga_od`i'
}

*square term
forvalues i=1(1)40{
gen omiga_odsq`i'=Omiga_i_sq*exp_`i'
}


save gravity_06.dta, replace


************************************
*Baseline Gravity model - 2006 
*Table 1 Column 3
***************************************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_*, noconstant r


*Code to retain Estimated INcome Elasticities and to graph them
matrix drop beta1 beta
matrix beta1=e(b)


preserve
keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop_d
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..43,1]
matrix gama=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0

*beta_n1 --> Income elasticities for each country
sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.

*Figure 1A
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 2006)") ytitle("Country-Income Elasticity, 2006") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_2006", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 

sort iso_d
save beta_2006.dta, replace
restore


*population-weighted gravity regression
reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in  omiga_od_* [weight=pop_d], noconstant r
outreg2 using gravity_cmm_wt, ctitle(2006) word se   bdec(2) sdec(2) replace


matrix drop beta1 beta gama_wt
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop_d
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..43,1]
matrix gama_wt=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0


sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 2006)") ytitle("Country-Income Elasticity (weighted-regression), 2006") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_wt_2006", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 

rename beta_n1 beta_wt
sort iso_d
save beta_wt_2006.dta, replace

restore



******************************
*Translog gravity
*Set all betas equal to zero
*****************************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in, noconstant r


matrix drop beta1 beta gama_tran
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop_d
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_tran=beta1[1..3,1]


sort iso_d
save beta_2006tran.dta, replace


restore


****************
*CES - gravity
****************

poisson tradeflow lndist nocontig nocomlang_off exp_1-exp_40 imp_1-imp_40, nocons robust

matrix drop beta1 beta gama_jn
matrix beta1=e(b)


preserve
keep if iso_o==iso_d
keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop_d tradeflow consumption_world consumption_total_d lndist nocontig nocomlang_off production_total_o

duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_jn=beta1[1..3,1]

gen mp1_jn=exp(-1*(lndist*gama_jn[1,1])+(nocontig*gama_jn[2,1])+(nocomlang_off*gama_jn[3,1]))

gen mpjn=(production_total_o*consumption_world)/((mp1_jn*tradeflow*consumption_world)^.5)
gen lnmpjn=ln(mpjn)

keep iso_d mp1_jn mpjn

sort iso_d
save beta_2006_ces.dta, replace

restore



*****************
*Non-linearities
*Quadratic term included
*****************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* omiga_odsq*, noconstant r
testparm omiga_odsq1-omiga_odsq40
testparm omiga_od_1-omiga_odsq40



************************
*Combine and collect income elasticities and trade cost vectors
************************


preserve

keep iso_o lndist_mean_weighted_o nocontig_mean_weighted_o nocomlang_mean_weighted_o omiga_total omiga_total_sq production_total_o consumption_world lndist_mean_weighted_forg_o  lndist_mean_weighted_dom_o nocomlang_mean_weighted_forg_o nocomlang_mean_weighted_dom_o nocontig_mean_weighted_forg_o nocontig_mean_weighted_dom_o omiga_total_forg omiga_total_dom 

duplicates drop
rename iso_o iso_d
gen prod_share=production_total_o/consumption_world

gen mp1=lndist_mean_weighted_o*gama[1,1]+nocontig_mean_weighted_o*gama[2,1]+nocomlang_mean_weighted_o*gama[3,1]
gen mp1_tran=lndist_mean_weighted_o*gama_tran[1,1]+nocontig_mean_weighted_o*gama_tran[2,1]+nocomlang_mean_weighted_o*gama_tran[3,1]
gen mp1_wt=lndist_mean_weighted_o*gama_wt[1,1]+nocontig_mean_weighted_o*gama_wt[2,1]+nocomlang_mean_weighted_o*gama_wt[3,1]
gen mp1_doma=lndist_mean_weighted_dom_o*gama[1,1]+nocontig_mean_weighted_dom_o*gama[2,1]+nocomlang_mean_weighted_dom_o*gama[3,1]
gen mp1_forg=lndist_mean_weighted_forg_o*gama[1,1]+nocontig_mean_weighted_forg_o*gama[2,1]+nocomlang_mean_weighted_forg_o*gama[3,1]


save country_variables.dta, replace

restore

preserve
keep iso_d lngdp_cap_real
duplicates drop
sort iso_d
save rgdp_pc.dta, replace

restore

use country_variables.dta, clear

sort iso_d
merge 1:1 iso_d using rgdp_pc.dta
drop _merge

sort iso_d
merge 1:1 iso_d using beta_2006.dta
drop _merge

sort iso_d
merge 1:1 iso_d using beta_2006_ces.dta
drop _merge

*Calculate Market Potential for 2006 = mp
gen year=2006
gen mp2=beta_n1*omiga_total
gen mp=mp1+mp2
gen mp2_forg=(beta_n1*omiga_total_forg)
gen mp_forg=mp1_forg+mp2_forg


save income_beta_2006.dta, replace


*********************************************
 
***GRAVITY FOR 1996*****

*********************************************

/*
use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\wiot_stata_sep12\wiot_full.dta", clear

*********1996*******************
keep if year==1995 | year==1996 |year==1997
keep if row_item<=35 


bysort row_country col_country row_item col_item: egen value_mean=mean(value)

keep if year==1996


rename row_country iso_o
rename col_country iso_d
drop row_item col_item


bysort iso_o iso_d: egen tradeflow=total(value_mean)

keep iso_o iso_d year tradeflow
drop if tradeflow<0
duplicates drop
replace iso_o="ROM" if iso_o=="ROU"
replace iso_d="ROM" if iso_d=="ROU"

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"



bysort iso_d: egen consumption_total_d=total(tradeflow)
bysort iso_o: egen production_total_o=total(tradeflow)

gen trade_share_wiod=tradeflow/consumption_total_d
keep iso_o iso_d year tradeflow trade_share_wiod consumption_total_d production_total_o
duplicates drop

sort iso_o iso_d year

save tradeflows_wiod_1996.dta, replace
*/


******inequality********
use inequality_wiid_2015.dta, clear

bysort iso3_o year: egen gini=mean(inequality)

keep if year==1995|year==1996 |year==1997
bysort iso3_o: egen gini_m=mean(gini)

replace year=1996

replace iso3_o="ROM" if iso3_o=="ROU"
rename iso3_o iso_o

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

keep iso_o year gini_m
duplicates drop

set obs 39
replace iso_o = "MLT" in 39
replace year = 1996 in 39
replace gini_m = 30 in 39

set obs 40
replace iso_o = "TUR" in 40
replace year = 1996 in 40
replace gini_m = 46.42 in 40

sort iso_o 

save inequality_wiid_1996_o.dta, replace

use gravity_variables_cepii.dta, clear

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


sort iso_o
merge m:1 iso_o using inequality_wiid_1996_o.dta
tab _merge
keep if _merge==3
drop _merge

ren gini_m inequality_o

preserve

use inequality_wiid_1996_o.dta, clear
ren iso_o iso_d
sort iso_d year
save inequality_wiid_1996_d.dta, replace

restore
sort iso_d year

merge m:1 iso_d year using inequality_wiid_1996_d.dta

tab _merge
keep if _merge==3
drop _merge

rename gini_m inequality_d

save gravity_ineq_40_1996.dta, replace




use gravity_ineq_40_1996.dta, clear

sort iso_o iso_d year
merge 1:1 iso_o iso_d year using tradeflows_wiod_1996.dta
keep if _merge==3
drop _merge



sort iso_o year
merge iso_o year using price_ctry_1996.dta

tab _merge
drop _merge


preserve 
keep iso_d consumption_total_d year
duplicates drop
bysort year: egen consumption_world=total(consumption_total_d)
keep year consumption_world
duplicates drop 
sort year
save consumption_total_1996.dta, replace


restore
sort year
merge m:1 year using consumption_total_1996.dta
tab _merge
drop _merge

gen trade_share_adj_wiod=trade_share_wiod-production_total_o/consumption_world

preserve

use penn_wt.dta, clear
keep if year==1996
keep iso_d year pop cgdp
replace iso_d="DEU" if iso_d=="GER"
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


duplicates drop
sort iso_d year
save penn_wt_1996.dta, replace

restore
sort iso_d year
merge m:1 iso_d year using penn_wt_1996.dta
drop _merge

gen lnconsumption_pc_d=ln(consumption_total_d/pop)
gen lntrade_wiod=ln(tradeflow)
gen lndist=ln(distw)
replace contig=1 if iso_o==iso_d
replace comlang_off=1 if iso_o==iso_d


bysort iso_d year: egen lndist_mean_d=mean(lndist)
gen dist_weighted=consumption_total_d/consumption_world*(lndist-lndist_mean)
bysort iso_o year: egen lndist_mean_weighted_o=total(dist_weighted)
gen D_in=lndist-lndist_mean_d-lndist_mean_weighted_o
gen d_in=lndist-lndist_mean_d

gen nocontig=1-contig
bysort iso_d year: egen nocontig_mean_d=mean(nocontig)
gen nocontig_weighted=consumption_total_d/consumption_world*(nocontig-nocontig_mean_d)
bysort iso_o year: egen nocontig_mean_weighted_o=total(nocontig_weighted)
gen Nocontig_in=nocontig-nocontig_mean_d-nocontig_mean_weighted_o
gen nocontig_in=nocontig-nocontig_mean_d

gen nocomlang_off=1-comlang_off
bysort iso_d year: egen nocomlang_mean_d=mean(nocomlang_off)
gen nocomlang_weighted=consumption_total_d/consumption_world*(nocomlang_off-nocomlang_mean_d)
bysort iso_o year: egen nocomlang_mean_weighted_o=total(nocomlang_weighted)
gen Nocomlang_in=nocomlang_off-nocomlang_mean_d-nocomlang_mean_weighted_o
gen nocomlang_in=nocomlang_off-nocomlang_mean_d


encode iso_o, gen(ctry_o)
encode iso_d, gen(ctry_d)


gen sigma=invnormal((inequality_d/100+1)/2)
gen theil_i=sigma^2
gen lngdp_cap_real=ln(cgdp)

gen price_w=(ln(qa_price_exp_all)+0.177*lndist)*trade_share_wiod
bysort iso_d year: egen price_d=total(price_w)
replace price_d=. if price_d==0

gen omiga_i=lnconsumption_pc-price_d+theil_i

preserve
keep iso_d omiga_i
duplicates drop
sort iso_d
save yn_1996.dta, replace
restore


gen omiga_i_w=omiga_i*consumption_total_d/consumption_world


*Allow for domestic and foreign MP
gen omiga_i_w_forg=omiga_i_w if iso_o!=iso_d
gen omiga_i_w_dom=omiga_i_w if iso_o==iso_d
bysort iso_o year: egen omiga_total_forg=total(omiga_i_w_forg)
bysort iso_o year: egen omiga_total_dom=total(omiga_i_w_dom)


gen dist_weighted_forg=dist_weighted if iso_o!=iso_d
gen dist_weighted_dom=dist_weighted  if iso_o==iso_d
bysort iso_o year: egen lndist_mean_weighted_forg_o=total(dist_weighted_forg)
bysort iso_o year: egen lndist_mean_weighted_dom_o=total(dist_weighted_dom)

gen nocomlang_weighted_forg=nocomlang_weighted if iso_o!=iso_d
gen nocomlang_weighted_dom=nocomlang_weighted  if iso_o==iso_d
bysort iso_o year: egen nocomlang_mean_weighted_forg_o=total(nocomlang_weighted_forg)
bysort iso_o year: egen nocomlang_mean_weighted_dom_o=total(nocomlang_weighted_dom)

gen nocontig_weighted_forg=nocontig_weighted if iso_o!=iso_d
gen nocontig_weighted_dom=nocontig_weighted if iso_o==iso_d
bysort iso_o year: egen nocontig_mean_weighted_forg_o=total(nocontig_weighted_forg)
bysort iso_o year: egen nocontig_mean_weighted_dom_o=total(nocontig_weighted_dom)



*For NL model
gen omiga_i_sq=omiga_i^2
gen omiga_i_sq_w=omiga_i_sq*consumption_total_d/consumption_world


preserve
keep iso_d year omiga_i_w omiga_i_sq_w
duplicates drop
bysort year: egen omiga_total=total(omiga_i_w)
bysort year: egen omiga_total_sq=total(omiga_i_sq_w)



keep year omiga_total omiga_total_sq
duplicates drop
sort year
save omiga_total.dta, replace

restore
sort year
merge m:1 year using omiga_total.dta

gen Omiga_i=omiga_i-omiga_total
gen Omiga_i_sq=omiga_i_sq-omiga_total_sq


drop if trade_share_adj_wiod==. | D_in==. | omiga_i==.
egen exp_group=group(ctry_o)
egen imp_group=group(ctry_d)

sum exp_group

forvalues i=1(1)40{
gen exp_`i'=0
replace exp_`i'=1 if exp_group==`i'

}

forvalues i=1(1)40{
gen imp_`i'=0
replace imp_`i'=1 if imp_group==`i'

}
forvalues i=1(1)40{
gen omiga_od`i'=Omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_i`i'=omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_od_`i'=omiga_od`i'
}

*square term
forvalues i=1(1)40{
gen omiga_odsq`i'=Omiga_i_sq*exp_`i'
}



save gravity_96.dta, replace


***********************
*Gravity 1996
*Table 1 Column 1
***********************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_*, noconstant r

matrix drop beta1 beta gama
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real  pop 
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..42,1]
matrix gama=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0



sum beta_n1
replace beta_n1=-1*r(sum) if beta_n1==.

*Figure 1A
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 1996)") ytitle("Country-Income Elasticity, 1996") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_1996", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 


sort iso_d
save beta_1996.dta, replace

restore





*******************
*Weighted Gravity
*******************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* [weight=pop], noconstant r

matrix drop beta1 beta gama_wt
matrix beta1=e(b)

preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..43,1]
matrix gama_wt=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0

sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.

rename beta_n1 beta_wt
sort iso_d
save beta_wt_1996.dta, replace


restore


******************************
*Translog-- 1996
*****************************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in, noconstant r


matrix drop beta1 beta gama_tran
matrix beta1=e(b)

preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d 
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_tran=beta1[1..3,1]


sort iso_d
save beta_1996tran.dta, replace


restore


****************
*CES - gravity
****************

poisson tradeflow lndist nocontig nocomlang_off exp_1-exp_40 imp_1-imp_40, nocons robust

matrix drop beta1 beta gama_jn
matrix beta1=e(b)


preserve
keep if iso_o==iso_d
keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d  tradeflow consumption_world production_total_o lndist nocontig nocomlang_off

duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_jn=beta1[1..3,1]

gen mp1_jn=exp(-1*(lndist*gama_jn[1,1]+nocontig*gama_jn[2,1]+nocomlang*gama_jn[3,1]))

gen mpjn=(production_total_o*consumption_world)/((mp1_jn*tradeflow*consumption_world)^.5)
gen lnmpjn=ln(mpjn)

keep iso_d mp1_jn mpjn

sort iso_d
save beta_1996_ces.dta, replace


restore




*****************
*Quadratic term
*Non-linearities
*****************


reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* omiga_odsq*, noconstant r
testparm omiga_odsq1-omiga_odsq40



preserve

keep iso_o lndist_mean_weighted_o nocontig_mean_weighted_o nocomlang_mean_weighted_o omiga_total omiga_total_sq production_total_o consumption_world lndist_mean_weighted_forg_o  lndist_mean_weighted_dom_o nocomlang_mean_weighted_forg_o nocomlang_mean_weighted_dom_o nocontig_mean_weighted_forg_o nocontig_mean_weighted_dom_o omiga_total_forg omiga_total_dom 


duplicates drop
rename iso_o iso_d
gen prod_share=production_total_o/consumption_world

	gen mp1=lndist_mean_weighted_o*gama[1,1]+nocontig_mean_weighted_o*gama[2,1]+nocomlang_mean_weighted_o*gama[3,1]	
	gen mp1_tran=lndist_mean_weighted_o*gama_tran[1,1]+nocontig_mean_weighted_o*gama_tran[2,1]+nocomlang_mean_weighted_o*gama_tran[3,1]	
	gen mp1_doma=lndist_mean_weighted_dom_o*gama[1,1]+nocontig_mean_weighted_dom_o*gama[2,1]+nocomlang_mean_weighted_dom_o*gama[3,1]
	gen mp1_forg=lndist_mean_weighted_forg_o*gama[1,1]+nocontig_mean_weighted_forg_o*gama[2,1]+nocomlang_mean_weighted_forg_o*gama[3,1]

save country_variables.dta, replace

restore

preserve
keep iso_d lngdp_cap_real
duplicates drop
sort iso_d
save rgdp_pc.dta, replace

restore

use country_variables.dta, clear

sort iso_d
merge 1:1 iso_d using rgdp_pc.dta
drop _merge

sort iso_d
merge 1:1 iso_d using beta_1996.dta
drop _merge

sort iso_d
merge 1:1 iso_d using beta_1996_ces.dta
drop _merge



gen year=1996
gen mp2=beta_n1*omiga_total
gen mp=mp1+mp2
gen mp2_forg=(beta_n1*omiga_total_forg)
gen mp_forg=mp1_forg+mp2_forg


save income_beta_1996.dta, replace



******************************

***GRAVITY FOR 2001*****

******************************

/*
use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\wiot_stata_sep12\wiot_full.dta", clear

*********2001*******************
keep if year==2000 | year==2001 |year==2002
keep if row_item<=35 

bysort row_country col_country row_item col_item: egen value_mean=mean(value)

keep if year==2001


rename row_country iso_o
rename col_country iso_d
drop row_item col_item


bysort iso_o iso_d: egen tradeflow=total(value_mean)

keep iso_o iso_d year tradeflow
drop if tradeflow<0
duplicates drop
replace iso_o="ROM" if iso_o=="ROU"
replace iso_d="ROM" if iso_d=="ROU"

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"



bysort iso_d: egen consumption_total_d=total(tradeflow)
bysort iso_o: egen production_total_o=total(tradeflow)

gen trade_share_wiod=tradeflow/consumption_total_d
keep iso_o iso_d year tradeflow trade_share_wiod consumption_total_d production_total_o
duplicates drop

sort iso_o iso_d year

save tradeflows_wiod_2001.dta, replace
*/



******inequality********
use inequality_wiid_2015.dta, clear
bysort iso3_o year: egen gini=mean(inequality)

keep if year==2000|year==2001 |year==2002
bysort iso3_o: egen gini_m=mean(gini)

replace year=2001

replace iso3_o="ROM" if iso3_o=="ROU"
rename iso3_o iso_o

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

keep iso_o year gini_m
duplicates drop

set obs 38
replace iso_o = "CYP" in 38
replace year = 2001 in 38
replace gini_m = 28 in 38

set obs 39
replace iso_o = "IND" in 39
replace year = 2001 in 39
replace gini_m = 31.1 in 39


set obs 40
replace iso_o = "KOR" in 40
replace year = 2001 in 40
replace gini_m = 34.4 in 40

sort iso_o 

save inequality_wiid_2001_o.dta, replace


use gravity_variables_cepii.dta, clear

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


sort iso_o
merge m:1 iso_o using inequality_wiid_2001_o.dta
tab _merge
keep if _merge==3
drop _merge

ren gini_m inequality_o

preserve

use inequality_wiid_2001_o.dta, clear
ren iso_o iso_d
sort iso_d year
save inequality_wiid_2001_d.dta, replace

restore
sort iso_d year

merge m:1 iso_d year using inequality_wiid_2001_d.dta

tab _merge
keep if _merge==3
drop _merge

rename gini_m inequality_d

save gravity_ineq_40_2001.dta, replace

use gravity_ineq_40_2001.dta, clear


sort iso_o iso_d year
merge 1:1 iso_o iso_d year using tradeflows_wiod_2001.dta

keep if _merge==3
drop _merge



sort iso_o year
merge iso_o year using price_ctry_2001.dta

tab _merge
drop _merge


preserve 
keep iso_d consumption_total_d year
duplicates drop
bysort year: egen consumption_world=total(consumption_total_d)
keep year consumption_world
duplicates drop 
sort year
save consumption_total_2001.dta, replace


restore
sort year
merge m:1 year using consumption_total_2001.dta
tab _merge
drop _merge

gen trade_share_adj_wiod=trade_share_wiod-production_total_o/consumption_world

preserve

use penn_wt.dta, clear
keep if year==2001
keep iso_d year pop cgdp
replace iso_d="DEU" if iso_d=="GER"
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


duplicates drop
sort iso_d year
save penn_wt_2001.dta, replace

restore
sort iso_d year
merge m:1 iso_d year using penn_wt_2001.dta
drop _merge

gen lnconsumption_pc_d=ln(consumption_total_d/pop)
gen lntrade_wiod=ln(tradeflow)
gen lndist=ln(distw)
replace contig=1 if iso_o==iso_d
replace comlang_off=1 if iso_o==iso_d



bysort iso_d year: egen lndist_mean_d=mean(lndist)
gen dist_weighted=consumption_total_d/consumption_world*(lndist-lndist_mean)
bysort iso_o year: egen lndist_mean_weighted_o=total(dist_weighted)
gen D_in=lndist-lndist_mean_d-lndist_mean_weighted_o
gen d_in=lndist-lndist_mean_d


gen nocontig=1-contig
bysort iso_d year: egen nocontig_mean_d=mean(nocontig)
gen nocontig_weighted=consumption_total_d/consumption_world*(nocontig-nocontig_mean_d)
bysort iso_o year: egen nocontig_mean_weighted_o=total(nocontig_weighted)
gen Nocontig_in=nocontig-nocontig_mean_d-nocontig_mean_weighted_o
gen nocontig_in=nocontig-nocontig_mean_d

gen nocomlang_off=1-comlang_off
bysort iso_d year: egen nocomlang_mean_d=mean(nocomlang_off)
gen nocomlang_weighted=consumption_total_d/consumption_world*(nocomlang_off-nocomlang_mean_d)
bysort iso_o year: egen nocomlang_mean_weighted_o=total(nocomlang_weighted)
gen Nocomlang_in=nocomlang_off-nocomlang_mean_d-nocomlang_mean_weighted_o
gen nocomlang_in=nocomlang_off-nocomlang_mean_d



encode iso_o, gen(ctry_o)
encode iso_d, gen(ctry_d)


gen sigma=invnormal((inequality_d/100+1)/2)
gen theil_i=sigma^2
gen lngdp_cap_real=ln(cgdp)

gen price_w=(ln(qa_price_exp_all)+0.177*lndist)*trade_share_wiod
bysort iso_d year: egen price_d=total(price_w)
replace price_d=. if price_d==0



gen omiga_i=lnconsumption_pc-price_d+theil_i
gen omiga_i_w=omiga_i*consumption_total_d/consumption_world

*Allow for domestic and foreign MP
gen omiga_i_w_forg=omiga_i_w if iso_o!=iso_d
gen omiga_i_w_dom=omiga_i_w if iso_o==iso_d
bysort iso_o year: egen omiga_total_forg=total(omiga_i_w_forg)
bysort iso_o year: egen omiga_total_dom=total(omiga_i_w_dom)


gen dist_weighted_forg=dist_weighted if iso_o!=iso_d
gen dist_weighted_dom=dist_weighted  if iso_o==iso_d
bysort iso_o year: egen lndist_mean_weighted_forg_o=total(dist_weighted_forg)
bysort iso_o year: egen lndist_mean_weighted_dom_o=total(dist_weighted_dom)

gen nocomlang_weighted_forg=nocomlang_weighted if iso_o!=iso_d
gen nocomlang_weighted_dom=nocomlang_weighted  if iso_o==iso_d
bysort iso_o year: egen nocomlang_mean_weighted_forg_o=total(nocomlang_weighted_forg)
bysort iso_o year: egen nocomlang_mean_weighted_dom_o=total(nocomlang_weighted_dom)

gen nocontig_weighted_forg=nocontig_weighted if iso_o!=iso_d
gen nocontig_weighted_dom=nocontig_weighted if iso_o==iso_d
bysort iso_o year: egen nocontig_mean_weighted_forg_o=total(nocontig_weighted_forg)
bysort iso_o year: egen nocontig_mean_weighted_dom_o=total(nocontig_weighted_dom)




*For NL model
gen omiga_i_sq=omiga_i^2
gen omiga_i_sq_w=omiga_i_sq*consumption_total_d/consumption_world
*



preserve
keep iso_d year omiga_i_w omiga_i_sq_w
duplicates drop
bysort year: egen omiga_total=total(omiga_i_w)
bysort year: egen omiga_total_sq=total(omiga_i_sq_w)


keep year omiga_total omiga_total_sq
duplicates drop
sort year
save omiga_total.dta, replace

restore
sort year
merge m:1 year using omiga_total.dta

gen Omiga_i=omiga_i-omiga_total
gen Omiga_i_sq=omiga_i_sq-omiga_total_sq

drop if trade_share_adj_wiod==. | D_in==. | omiga_i==.
egen exp_group=group(ctry_o)
egen imp_group=group(ctry_d)

sum exp_group

forvalues i=1(1)40{
gen exp_`i'=0
replace exp_`i'=1 if exp_group==`i'

}

forvalues i=1(1)40{
gen imp_`i'=0
replace imp_`i'=1 if imp_group==`i'

}
forvalues i=1(1)40{
gen omiga_od`i'=Omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_i`i'=omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_od_`i'=omiga_od`i'
}

*square term
forvalues i=1(1)40{
gen omiga_odsq`i'=Omiga_i_sq*exp_`i'
}


save gravity_01.dta, replace



*****************************
*Gravity 2001
*Table 1 Column 2
*****************************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_*, noconstant r


matrix drop beta1 beta gama
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real pop
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..42,1]
matrix gama=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0


sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 2001)") ytitle("Country-Income Elasticity, 2001") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_2001", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 


sort iso_d
save beta_2001.dta, replace


restore




*******************
*weighted gravity regression
*******************8


reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* [weight=pop], noconstant r

matrix drop beta1 beta gama_wt
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..43,1]
matrix gama_wt=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0

sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 2001)") ytitle("Country-Income Elasticity (weighted-regression), 2001") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_wt_2001", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 

rename beta_n1 beta_wt
sort iso_d
save beta_wt_2001.dta, replace


restore


******************************
*Translog-- 
*****************************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in, noconstant r

matrix drop beta1 beta gama_tran
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop_d
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_tran=beta1[1..3,1]


sort iso_d
save beta_2001tran.dta, replace


restore



****************
*CES - gravity
****************

poisson tradeflow lndist nocontig nocomlang_off exp_1-exp_40 imp_1-imp_40, nocons robust

matrix drop beta1 beta gama_jn
matrix beta1=e(b)


preserve
keep if iso_o==iso_d
keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d tradeflow consumption_world production_total_o lndist nocontig nocomlang_off

duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_jn=beta1[1..3,1]

gen mp1_jn=exp(-1*(lndist*gama_jn[1,1]+nocontig*gama_jn[2,1]+nocomlang*gama_jn[3,1]))

gen mpjn=(production_total_o*consumption_world)/((mp1_jn*tradeflow*consumption_world)^.5)
gen lnmpjn=ln(mpjn)

keep iso_d mp1_jn mpjn

sort iso_d
save beta_2001_ces.dta, replace


restore



*****************
*Non-linearities
*****************


reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* omiga_odsq*, noconstant r
testparm omiga_odsq1-omiga_odsq40
testparm omiga_od_1-omiga_odsq40



*Generate market potential terms for 2001
preserve

keep iso_o lndist_mean_weighted_o nocontig_mean_weighted_o nocomlang_mean_weighted_o omiga_total omiga_total_sq production_total_o consumption_world lndist_mean_weighted_forg_o  lndist_mean_weighted_dom_o nocomlang_mean_weighted_forg_o nocomlang_mean_weighted_dom_o nocontig_mean_weighted_forg_o nocontig_mean_weighted_dom_o omiga_total_forg omiga_total_dom 



duplicates drop
rename iso_o iso_d
gen prod_share=production_total_o/consumption_world


	gen mp1=lndist_mean_weighted_o*gama[1,1]+nocontig_mean_weighted_o*gama[2,1]+nocomlang_mean_weighted_o*gama[3,1]	
	gen mp1_tran=lndist_mean_weighted_o*gama_tran[1,1]+nocontig_mean_weighted_o*gama_tran[2,1]+nocomlang_mean_weighted_o*gama_tran[3,1]
	gen mp1_doma=lndist_mean_weighted_dom_o*gama[1,1]+nocontig_mean_weighted_dom_o*gama[2,1]+nocomlang_mean_weighted_dom_o*gama[3,1]
	gen mp1_forg=lndist_mean_weighted_forg_o*gama[1,1]+nocontig_mean_weighted_forg_o*gama[2,1]+nocomlang_mean_weighted_forg_o*gama[3,1]

save country_variables.dta, replace

restore

preserve
keep iso_d lngdp_cap_real
duplicates drop
sort iso_d
save rgdp_pc.dta, replace

restore

use country_variables.dta, clear

sort iso_d
merge 1:1 iso_d using rgdp_pc.dta
drop _merge

sort iso_d
merge 1:1 iso_d using beta_2001.dta
drop _merge


sort iso_d
merge 1:1 iso_d using beta_2001_ces.dta
drop _merge



gen year=2001
gen mp2=beta_n1*omiga_total
gen mp=mp1+mp2
gen mp2_forg=(beta_n1*omiga_total_forg)
gen mp_forg=mp1_forg+mp2_forg


save income_beta_2001.dta, replace


*********************************

****GRAVITY FOR 2011*******

*********************************

/*
use "C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\wiot_stata_sep12\wiot_full.dta", clear


*********2011*******************
keep if year==2009 | year==2010 | year==2011 
keep if row_item<=35 


bysort row_country col_country row_item col_item: egen value_mean=mean(value)

keep if year==2011


rename row_country iso_o
rename col_country iso_d
drop row_item col_item


bysort iso_o iso_d: egen tradeflow=total(value_mean)

keep iso_o iso_d year tradeflow
drop if tradeflow<0
duplicates drop


replace iso_o="ROM" if iso_o=="ROU"
replace iso_d="ROM" if iso_d=="ROU"

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


bysort iso_d: egen consumption_total_d=total(tradeflow)
bysort iso_o: egen production_total_o=total(tradeflow)

gen trade_share_wiod=tradeflow/consumption_total_d
keep iso_o iso_d year tradeflow trade_share_wiod consumption_total_d production_total_o
duplicates drop

sort iso_o iso_d year

save tradeflows_wiod_2011.dta, replace
*/


******inequality********
use inequality_wiid_2015.dta, clear

bysort iso3_o year: egen gini=mean(inequality)

keep if year==2010 | year==2011
bysort iso3_o: egen gini_m=mean(gini)

replace year=2011

replace iso3_o="ROM" if iso3_o=="ROU"
rename iso3_o iso_o

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 

keep iso_o year gini_m
duplicates drop

set obs 40
replace iso_o = "JPN" in 40
replace year = 2011 in 40
replace gini_m = 37.8 in 40
replace gini_m=54.7 if iso_o=="BRA"
sort iso_o 

save inequality_wiid_2011_o.dta, replace

use gravity_variables_cepii.dta, clear

keep if iso_o=="USA" |iso_o=="JPN" | iso_o=="CHN" |iso_o=="DEU" | iso_o=="GBR" |iso_o=="FRA" | iso_o=="ITA" |iso_o=="ESP" |iso_o=="CAN" |iso_o=="KOR" | iso_o=="IND" |iso_o=="BRA" | iso_o=="RUS" |iso_o=="MEX" | iso_o=="AUS" |iso_o=="NLD" |iso_o=="TUR" |iso_o=="BEL" | iso_o=="TWN" |iso_o=="SWE" | iso_o=="POL" |iso_o=="IND" | iso_o=="AUT" |iso_o=="DNK" |iso_o=="GRC" |iso_o=="IRL" | iso_o=="FIN" |iso_o=="PRT" | iso_o=="CZE" |iso_o=="ROM" | iso_o=="HUN" |iso_o=="SVK" |iso_o=="LUX" |iso_o=="SVN" | iso_o=="BGR" |iso_o=="LTU" | iso_o=="LVA" |iso_o=="EST" | iso_o=="CYP" | iso_o=="MLT" |iso_o=="IDN" 
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


sort iso_o
merge m:1 iso_o using inequality_wiid_2011_o.dta
tab _merge
keep if _merge==3
drop _merge

ren gini_m inequality_o

preserve

use inequality_wiid_2011_o.dta, clear
ren iso_o iso_d
sort iso_d year
save inequality_wiid_2011_d.dta, replace

restore
sort iso_d year

merge m:1 iso_d year using inequality_wiid_2011_d.dta

tab _merge
keep if _merge==3
drop _merge

rename gini_m inequality_d

save gravity_ineq_40_2011.dta, replace



use gravity_ineq_40_2011.dta, clear

sort iso_o iso_d year

merge 1:1 iso_o iso_d year using tradeflows_wiod_2011.dta

keep if _merge==3
drop _merge

sort iso_o year
merge iso_o year using price_ctry_2011.dta

tab _merge
drop _merge


preserve 
keep iso_d consumption_total_d year
duplicates drop
bysort year: egen consumption_world=total(consumption_total_d)
keep year consumption_world
duplicates drop 
sort year
save consumption_total_2011.dta, replace


restore
sort year
merge m:1 year using consumption_total_2011.dta
tab _merge
drop _merge

gen trade_share_adj_wiod=trade_share_wiod-production_total_o/consumption_world

preserve

use penn_wt.dta, clear
keep if year==2010
replace year=2011
keep iso_d year pop cgdp
replace iso_d="DEU" if iso_d=="GER"
keep if iso_d=="USA" |iso_d=="JPN" | iso_d=="CHN" |iso_d=="DEU" | iso_d=="GBR" |iso_d=="FRA" | iso_d=="ITA" |iso_d=="ESP" |iso_d=="CAN" |iso_d=="KOR" | iso_d=="IND" |iso_d=="BRA" | iso_d=="RUS" |iso_d=="MEX" | iso_d=="AUS" |iso_d=="NLD" |iso_d=="TUR" |iso_d=="BEL" | iso_d=="TWN" |iso_d=="SWE" | iso_d=="POL" |iso_d=="IND" | iso_d=="AUT" |iso_d=="DNK" |iso_d=="GRC" |iso_d=="IRL" | iso_d=="FIN" |iso_d=="PRT" | iso_d=="CZE" |iso_d=="ROM" | iso_d=="HUN" |iso_d=="SVK" |iso_d=="LUX" |iso_d=="SVN" | iso_d=="BGR" |iso_d=="LTU" | iso_d=="LVA" |iso_d=="EST" | iso_d=="CYP" | iso_d=="MLT" |iso_d=="IDN"


duplicates drop
sort iso_d year
save penn_wt_2011.dta, replace

restore
sort iso_d year
merge m:1 iso_d year using penn_wt_2011.dta
drop _merge

gen lnconsumption_pc_d=ln(consumption_total_d/pop)
gen lntrade_wiod=ln(tradeflow)
gen lndist=ln(distw)
replace contig=1 if iso_o==iso_d
replace comlang_off=1 if iso_o==iso_d


bysort iso_d year: egen lndist_mean_d=mean(lndist)
gen dist_weighted=consumption_total_d/consumption_world*(lndist-lndist_mean)
bysort iso_o year: egen lndist_mean_weighted_o=total(dist_weighted)
gen D_in=lndist-lndist_mean_d-lndist_mean_weighted_o
gen d_in=lndist-lndist_mean_d

gen nocontig=1-contig
bysort iso_d year: egen nocontig_mean_d=mean(nocontig)
gen nocontig_weighted=consumption_total_d/consumption_world*(nocontig-nocontig_mean_d)
bysort iso_o year: egen nocontig_mean_weighted_o=total(nocontig_weighted)
gen Nocontig_in=nocontig-nocontig_mean_d-nocontig_mean_weighted_o
gen nocontig_in=nocontig-nocontig_mean_d

gen nocomlang_off=1-comlang_off
bysort iso_d year: egen nocomlang_mean_d=mean(nocomlang_off)
gen nocomlang_weighted=consumption_total_d/consumption_world*(nocomlang_off-nocomlang_mean_d)
bysort iso_o year: egen nocomlang_mean_weighted_o=total(nocomlang_weighted)
gen Nocomlang_in=nocomlang_off-nocomlang_mean_d-nocomlang_mean_weighted_o
gen nocomlang_in=nocomlang_off-nocomlang_mean_d


encode iso_o, gen(ctry_o)
encode iso_d, gen(ctry_d)

gen sigma=invnormal((inequality_d/100+1)/2)
gen theil_i=sigma^2
gen lngdp_cap_real=ln(cgdp)

gen price_w=(ln(qa_price_exp_all)+0.177*lndist)*trade_share_wiod
bysort iso_d year: egen price_d=total(price_w)
replace price_d=. if price_d==0



gen omiga_i=lnconsumption_pc-price_d+theil_i
gen omiga_i_w=omiga_i*consumption_total_d/consumption_world

*Allow for domestic and foreign MP
gen omiga_i_w_forg=omiga_i_w if iso_o!=iso_d
gen omiga_i_w_dom=omiga_i_w if iso_o==iso_d
bysort iso_o year: egen omiga_total_forg=total(omiga_i_w_forg)
bysort iso_o year: egen omiga_total_dom=total(omiga_i_w_dom)


gen dist_weighted_forg=dist_weighted if iso_o!=iso_d
gen dist_weighted_dom=dist_weighted  if iso_o==iso_d
bysort iso_o year: egen lndist_mean_weighted_forg_o=total(dist_weighted_forg)
bysort iso_o year: egen lndist_mean_weighted_dom_o=total(dist_weighted_dom)

gen nocomlang_weighted_forg=nocomlang_weighted if iso_o!=iso_d
gen nocomlang_weighted_dom=nocomlang_weighted  if iso_o==iso_d
bysort iso_o year: egen nocomlang_mean_weighted_forg_o=total(nocomlang_weighted_forg)
bysort iso_o year: egen nocomlang_mean_weighted_dom_o=total(nocomlang_weighted_dom)

gen nocontig_weighted_forg=nocontig_weighted if iso_o!=iso_d
gen nocontig_weighted_dom=nocontig_weighted if iso_o==iso_d
bysort iso_o year: egen nocontig_mean_weighted_forg_o=total(nocontig_weighted_forg)
bysort iso_o year: egen nocontig_mean_weighted_dom_o=total(nocontig_weighted_dom)


*For NL model
gen omiga_i_sq=omiga_i^2
gen omiga_i_sq_w=omiga_i_sq*consumption_total_d/consumption_world


preserve
keep iso_d year omiga_i_w omiga_i_sq_w
duplicates drop

bysort year: egen omiga_total=total(omiga_i_w)
bysort year: egen omiga_total_sq=total(omiga_i_sq_w)

keep year omiga_total omiga_total_sq


duplicates drop
sort year
save omiga_total.dta, replace

restore
sort year
merge m:1 year using omiga_total.dta

gen Omiga_i=omiga_i-omiga_total
gen Omiga_i_sq=omiga_i_sq-omiga_total_sq


drop if trade_share_adj_wiod==. | D_in==. | omiga_i==.
egen exp_group=group(ctry_o)
egen imp_group=group(ctry_d)

sum exp_group

forvalues i=1(1)40{
gen exp_`i'=0
replace exp_`i'=1 if exp_group==`i'

}

forvalues i=1(1)40{
gen imp_`i'=0
replace imp_`i'=1 if imp_group==`i'

}
forvalues i=1(1)40{
gen omiga_od`i'=Omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_i`i'=omiga_i*exp_`i'
}

forvalues i=1(1)40{
gen omiga_od_`i'=omiga_od`i'
}

*square term
forvalues i=1(1)40{
gen omiga_odsq`i'=Omiga_i_sq*exp_`i'
}


save gravity_11.dta, replace


****************************
*Gravity 2011
*Table 1 Column 4
****************************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_*, noconstant r

matrix drop beta1 beta gama
matrix beta1=e(b)

preserve

keep iso_d imp_group lngdp_cap_real pop
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..42,1]
matrix gama=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0

sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 2011)") ytitle("Country-Income Elasticity (quadratic), 2011") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_2011", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 


sort iso_d
save beta_2011.dta, replace


restore




****************
*weighted regression
****************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* [weight=pop], noconstant r

matrix drop beta1 beta gama_wt
matrix beta1=e(b)

preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix beta=beta1[4..43,1]
matrix gama_wt=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0

sum beta_n1

replace beta_n1=-1*r(sum) if beta_n1==.
twoway (scatter beta_n1 lngdp_cap_real, mlabel(iso_d) xtitle("ln (Real GDP per capita, 2011)") ytitle("Country-Income Elasticity (weighted-regression), 2011") saving("C:\Users\cmm\Dropbox\Papers_shared\Non-homothetic and MP\data analysis\beta_ycap_wt_2011", replace))(lfit beta_n1 lngdp_cap_real, legend(off)) 

rename beta_n1 beta_wt
sort iso_d
save beta_wt_2011.dta, replace

restore


******************************
*Translog-- 2011
*****************************


reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in, noconstant r

matrix drop beta1 beta gama_tran
matrix beta1=e(b)


preserve

keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d pop_d
duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_tran=beta1[1..3,1]


sort iso_d
save beta_2011tran.dta, replace


restore


****************
*CES - gravity
****************

poisson tradeflow lndist nocontig nocomlang_off exp_1-exp_40 imp_1-imp_40, nocons robust

matrix drop beta1 beta gama_jn
matrix beta1=e(b)


preserve
keep if iso_o==iso_d
keep iso_d imp_group lngdp_cap_real omiga_i lnconsumption_pc_d tradeflow consumption_world production_total_o lndist nocontig nocomlang_off

duplicates drop
sort imp_group

matrix beta1=beta1'
matrix gama_jn=beta1[1..3,1]

gen mp1_jn=exp(-1*(lndist*gama_jn[1,1]+nocontig*gama_jn[2,1]+nocomlang*gama_jn[3,1]))

gen mpjn=(production_total_o*consumption_world)/((mp1_jn*tradeflow*consumption_world)^.5)
gen lnmpjn=ln(mpjn)

keep iso_d mp1_jn mpjn

sort iso_d
save beta_2011_ces.dta, replace


restore


*****************
*Non-linearities
*****************

reg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* omiga_odsq*, noconstant r
testparm omiga_odsq1-omiga_odsq40


preserve

keep iso_o lndist_mean_weighted_o nocontig_mean_weighted_o nocomlang_mean_weighted_o omiga_total omiga_total_sq production_total_o consumption_world lndist_mean_weighted_forg_o  lndist_mean_weighted_dom_o nocomlang_mean_weighted_forg_o nocomlang_mean_weighted_dom_o nocontig_mean_weighted_forg_o nocontig_mean_weighted_dom_o omiga_total_forg omiga_total_dom 
	

duplicates drop
rename iso_o iso_d
gen prod_share=production_total_o/consumption_world

	gen mp1=lndist_mean_weighted_o*gama[1,1]+nocontig_mean_weighted_o*gama[2,1]+nocomlang_mean_weighted_o*gama[3,1]	
	gen mp1_tran=lndist_mean_weighted_o*gama_tran[1,1]+nocontig_mean_weighted_o*gama_tran[2,1]+nocomlang_mean_weighted_o*gama_tran[3,1]
	gen mp1_doma=lndist_mean_weighted_dom_o*gama[1,1]+nocontig_mean_weighted_dom_o*gama[2,1]+nocomlang_mean_weighted_dom_o*gama[3,1]
	gen mp1_forg=lndist_mean_weighted_forg_o*gama[1,1]+nocontig_mean_weighted_forg_o*gama[2,1]+nocomlang_mean_weighted_forg_o*gama[3,1]

save country_variables.dta, replace

restore

preserve
keep iso_d lngdp_cap_real
duplicates drop
sort iso_d
save rgdp_pc.dta, replace

restore

use country_variables.dta, clear

sort iso_d
merge 1:1 iso_d using rgdp_pc.dta
drop _merge

sort iso_d
merge 1:1 iso_d using beta_2011.dta
drop _merge


sort iso_d
merge 1:1 iso_d using beta_2011_ces.dta
drop _merge


gen year=2011
gen mp2=beta_n1*omiga_total
gen mp=mp1+mp2
gen mp2_forg=(beta_n1*omiga_total_forg)
gen mp_forg=mp1_forg+mp2_forg


save income_beta_2011.dta, replace



******************************
*Panel/Pooled models for Gravity
*Table 1 COlumn 5 and 6
*Also create market potential based on income elasticities from a pooled model
*******************************

use gravity_96.dta, clear
append using gravity_06.dta
append using gravity_01.dta
append using gravity_11.dta

egen cty_pair=group(iso_o iso_d)
xtset cty_pair year


*Table 1 Column 5 - Dyadic fixed effects
xtreg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* i.year, fe


*Table 1 Column 6 -- Pooled
xtreg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* i.year, re


***************************************
*Panel Gravity model
*use panel estimates to get market potential
***************************************


use gravity_96.dta, clear
append using gravity_06.dta
append using gravity_01.dta
append using gravity_11.dta

egen cty_pair=group(iso_o iso_d)
xtset cty_pair year


xtreg trade_share_adj_wiod D_in Nocomlang_in Nocontig_in omiga_od_* i.year, fe


preserve

keep if year==2011
keep iso_d imp_group lngdp_cap_real year
drop year
duplicates drop
sort imp_group


matrix drop beta1 beta gama
matrix beta1=e(b)
matrix beta1=beta1'
matrix beta=beta1[4..43,1]
matrix gama=beta1[1..3,1]
svmat beta, names(beta_n)
replace beta_n1=. if beta_n1==0


sort iso_d
save beta_dif_all.dta, replace

restore

preserve

keep iso_o year lndist_mean_weighted_o nocontig_mean_weighted_o nocomlang_mean_weighted_o omiga_total production_total_o consumption_world
duplicates drop
rename iso_o iso_d
gen prod_share=production_total_o/consumption_world

gen mp1=lndist_mean_weighted_o*gama[1,1]+nocontig_mean_weighted_o*gama[2,1]+nocomlang_mean_weighted_o*gama[3,1]

sort iso_d year

save country_variables.dta, replace

restore

preserve
keep iso_d year lngdp_cap_real
duplicates drop
sort iso_d year
save rgdp_pc.dta, replace

restore

use country_variables.dta, clear

sort iso_d year
merge 1:1 iso_d year using rgdp_pc.dta
drop _merge

sort iso_d
merge n:1 iso_d using beta_dif_all.dta
drop _merge

gen mp2=beta_n1*omiga_total
gen mp=mp1+mp2
save MP_panel_all.dta, replace

egen id=group(iso_d)
xtset id year
xtreg lngdp_cap_real mp, fe

keep imp_group mp mp2 mp1 beta_n1 year iso_d
rename mp mp_panel
rename mp2 mp2_panel
rename mp1 mp1_panel
rename beta_n1 beta_panel

sort iso_d year
save MP_panel.dta, replace





*****************************

*****Make panel dataset for wage regressions***

*****************************

use income_beta_2011.dta, clear
append using income_beta_2001.dta
append using income_beta_1996.dta
append using income_beta_2006.dta
encode iso_d, gen(iso)

save income_beta.dta, replace

use ctry_data.dta, clear
ren iso3 iso_d
replace pop=22.9 if iso_d=="TWN" & year==2006
keep iso_d year pop area
duplicates drop
sort iso_d year
save ctry_data_pop.dta, replace


use penn_wt_2011.dta
replace pop=pop/1000
	keep iso_d year pop
save pop2011.dta, replace


use ctry_data_pop.dta, replace
append using pop2011.dta
save ctry_data_pop.dta, replace



use income_beta.dta, clear
sort iso_d year
merge 1:1 iso_d year using ctry_data_pop.dta
keep if _merge==3
drop _merge

*TWN is missing in WB data.
merge 1:1 iso_d year using "wb_gdp.dta"
keep if _merge==3
drop _merge



gen lnpop=ln(pop)
replace lnpop=ln(pop_d) if year==2006
gen lnarea=ln(area)
gen ngdpcap=ngdpusd/popwb

gen pop2=pop
replace pop2=pop_d if pop2==.


*Real adjusted GDP/capita
gen lngdp_cap_adj=lngdp_cap_real+prod_share
*Nominal adjusted GDP/capita
gen ln_ngdpcap_adj=ln(ngdpcap)+prod_share
*Log of nominal GDP per capita
gen ln_ngdpcap=ln(ngdpcap)


**Allows for time-series operators despite gaps in years with fyear
gen fyear=1 if year==1996
replace fyear=2 if year==2001
replace fyear=3 if year==2006
replace fyear=4 if year==2011

tab fyear , gen(time) 

egen id=group(iso_d)
xtset id fyear


merge 1:1 iso_d year using MP_panel.dta

*Use 2 years ahead for World Bank Data 

drop _merge

merge 1:1 iso_d year using  "wb_gdp_forward.dta"
drop if _merge==2
drop _merge
label var ln_ngdpcap_f "log of WB nominal GDP per capita"



*Log of Jacks-Novy Market Potential
gen lnmpjn=ln(mpjn)


merge 1:1 iso_d year using controls_dan.dta
drop _merge

merge m:1 iso_d year using "gdpf2.dta"
drop if _merge==2
drop _merge


merge m:1 iso_d year using "gdp_share_f2.dta"
drop if _merge==2
drop _merge


*Nominal and forward adjusted GDP/capita -Penn WT
gen lncgdp_pc_f_adj=lncgdp_pc_f+cgdp_share_f2



***************************************************
***wage regressions***
***************************************************

*TABLE 2 Columns 1-4
reg lncgdp_pc_f_adj mp if year==1996 [aweight=pop2], r
reg lncgdp_pc_f_adj  mp if year==2001 [aweight=pop2], r
reg lncgdp_pc_f_adj  mp  if year==2006 [aweight=pop2], r
reg lncgdp_pc_f_adj  mp  if year==2011 [aweight=pop2], r


*Panel regressions
*Table 4 Column 5
xtreg lncgdp_pc_f_adj  mp i.year , re robust

bysort id: egen pop2_ave=mean(pop2)
xtreg lncgdp_pc_f_adj  mp i.year [aweight=pop2_ave], fe robust



*****************************************************************
*Foreign MP only
*Table 3
*****************************************************************

*Table 3 Columns 1-4
reg lncgdp_pc_f_adj mp_forg  if year==1996 [aweight=pop2], r
reg lncgdp_pc_f_adj mp_forg if year==2001 [aweight=pop2], r
reg lncgdp_pc_f_adj mp_forg if year==2006 [aweight=pop2], r
reg lncgdp_pc_f_adj mp_forg if year==2011 [aweight=pop2], r


*Panel regressions
*Table 3 Column 5
xtreg lncgdp_pc_f_adj mp_forg i.year , re robust
*Column 6
xtreg lncgdp_pc_f_adj  mp_forg i.year [aweight=pop2_ave], fe robust



***************************************
*Table 5
*Compare Translog, CES and Non-Homothetic
****************************************

*Generate and fix the sample
reg lncgdp_pc_f  mp if year==1996 [aweight=pop2], r
preserve
keep if e(sample)==1
gen jnsamp=1

*Make standardized data within sample

	egen float zy=std(lncgdp_pc_f), mean(0) std(1)
	egen float zya=std(lncgdp_pc_f_adj), mean(0) std(1)
	egen float zmp=std(mp), mean(0) std(1)
	egen float zpop=std(lnpop), mean(0) std(1)
	egen float zmptr=std(mp1_tran), mean(0) std(1)
	egen float zmpjn=std(lnmpjn), mean(0) std(1)
	egen float zmprv=std(lrmp_rv), mean(0) std(1)
	
*Col.1 
reg zy zmp [aweight=pop2], r
*Col. 2
reg zy zmptr [aweight=pop2], r
*Col. 3
reg zy zmpjn [aweight=pop2], r
*Col. 4
reg zy zmprv [aweight=pop2], r

restore


*Pooled	 models (Table 5 Cols. 5-7)
reg lncgdp_pc_f  mp [aweight=pop2], r
preserve
gen jnsamp2=e(sample)

keep if jnsamp2==1
	egen float zy=std(lncgdp_pc_f), mean(0) std(1)
	egen float zmp=std(mp), mean(0) std(1)
	egen float zpop=std(lnpop), mean(0) std(1)
	egen float zmptr=std(mp1_tran), mean(0) std(1)
	egen float zmpjn=std(lnmpjn), mean(0) std(1)

reg  zy zmp i.year if jnsamp2==1 [aweight=pop2], r cluster(iso_d)
reg zy zmptr i.year if jnsamp2==1 [aweight=pop2], r cluster(iso_d)
reg  zy zmpjn  i.year [aweight=pop2], r cluster(iso_d)

restore



************************************
*Investigate long run changes
************************************

sort id fyear
gen dmp=mp-l3.mp
gen dmp_pan=mp_panel-l3.mp_panel
gen dyadj=ln_ngdpcap_adj-l3.ln_ngdpcap_adj


***Figures 2A - 2B 
scatter dyadj dmp [aweight=pop2], ms(i) msymbol(Oh) || scatter dyadj dmp [aweight=pop2], ms(i) msymbol(i) mlabel(iso_d) || lfit dyadj dmp [aweight=pop2],  xtitle("Change in Market Potential") ytitle("Change in adjusted ln(GDP/capita), 1996-2011") legend(off)
scatter dyadj dmp_pan [aweight=pop2], ms(i) msymbol(Oh) || scatter dyadj dmp_pan [aweight=pop2], ms(i) msymbol(i) mlabel(iso_d) || lfit dyadj dmp_pan [aweight=pop2],  xlabel(-.03(.02).06) xtitle("Change in Market Potential") ytitle("Change in adjusted ln(GDP/capita), 1996-2011") legend(off)




*Figure 3, 1996
*Graph GDP vs MP - NH 
reg ln_ngdpcap mp if year==1996 [aweight=pop2], r
scatter  ln_ngdpcap mp if year==1996 [w=pop2], ms(i) msymbol(Oh) xtitle("MP-AIDS model") ytitle("ln(GDP per capita)") || scatter ln_ngdpcap mp if year==1996 [w=pop2], ms(i) msymbol(i) mlabel(iso_d) || lfit ln_ngdpcap mp if year==1996   [w=pop2], legend(off)


*Figure 4, 1996
*Graph GDP vs MP-TRANSLOG
reg ln_ngdpcap mp1_tran if year==1996 [aweight=pop2], r
scatter  ln_ngdpcap mp1_tran if year==1996 [w=pop2], ms(i) msymbol(Oh) xtitle("MP-Translog model") ytitle("ln(GDP per capita)") || scatter ln_ngdpcap mp1_tran if year==1996 [w=pop2], ms(i) msymbol(i) mlabel(iso_d) || lfit ln_ngdpcap mp1_tran if year==1996   [w=pop2], legend(off)


*Figure 5, 1996
*Graph GDP vs MP - CES
reg ln_ngdpcap lnmpjn if year==1996 [aweight=pop2], r
scatter  ln_ngdpcap lnmpjn if year==1996 [w=pop2], ms(i) msymbol(Oh) xtitle("MP-CES model") ytitle("ln(GDP per capita)") || scatter ln_ngdpcap lnmpjn if year==1996 [w=pop2], ms(i) msymbol(i) mlabel(iso_d) || lfit ln_ngdpcap lnmpjn if year==1996   [w=pop2], legend(off)



*Figures 6-8 
/*EXCLUDED IN JDE R2
*These compare predicted values from each model with actual. Plotted line is the 45-degree line

reg lncgdp_pc_f  lnmpjn if year==1996 [aweight=pop2], r
predict yhat_jn
gen jnsamp=1 if e(sample)==1

reg lncgdp_pc_f  mp if year==1996 [aweight=pop2], r
predict yhat_lm

reg lncgdp_pc_f  mp1_tran if year==1996 [aweight=pop2], r
predict yhat_tran


*Figure 6 -- Non-homotehtic
twoway (scatter yhat_lm lncgdp_pc_f if year==1996 & jnsamp==1, sort mlabel(iso_d) xtitle("ln(GDP per capita)") ytitle("Predicted ln(GDP cap.) MP-Non-Homothetic model") ylabel(7(1)11) xlabel(7(1)12) )  (line yhat_lm yhat_lm)
reg yhat_lm lncgdp_pc_f if year==1996 & jnsamp==1 [aweight=pop2], r


*Figure 7 -- Translog
twoway (scatter yhat_tran lncgdp_pc_f if year==1996 & jnsamp==1, sort mlabel(iso_d) xtitle("ln( GDP per capita)") ytitle("Predicted ln(GDP cap.) MP-CES model") ylabel(7(1)12) xlabel(7(1)12) )  (line yhat_jn yhat_jn, legend(off))
reg yhat_tran lncgdp_pc_f if year==1996 & jnsamp==1 [aweight=pop2], r

*Figure 8 -- MP-CES
twoway (scatter yhat_jn lncgdp_pc_f if year==1996 & jnsamp==1, sort mlabel(iso_d) xtitle("ln( GDP per capita)") ytitle("Predicted ln(GDP cap.) MP-CES model") ylabel(7(1)12) xlabel(7(1)12) )  (line yhat_jn yhat_jn, legend(off))
reg yhat_jn lncgdp_pc_f if year==1996 & jnsamp==1 [aweight=pop2], r

drop jnsamp yhat_jn yhat_lm
*/



*****************************************************************
*Table 4
***Augmented wage regression***
*****************************************************************

*add in cultivated land for Taiwan
replace arabland=(6242.1489/35980) if year==2001 & iso_d=="TWN"
*Source: Land Area in km^2 from CIA world factbook: https://www.cia.gov/library/publications/the-world-factbook/fields/2097.html
*Cultivated land from Statistics Taiwan: https://eng.stat.gov.tw/ct.asp?xItem=7232&ctNode=1634&mp=5

bysort iso_d: egen area_m=mean(area)
gen arabland_a=(arabland/100)*area_m
gen lnarabcap=ln(arabland_a/pop2)

drop _merge
merge m:1 iso_d using "region_dummies.dta"
tab region, gen(reg) 
drop _merge


*New variable PR = political rights from Freedom House
*data were in string format 
gen prn=real(pr)

*Need to make countries iso
merge 1:1 iso_d year using "poldata.dta"
drop if _merge==2
drop _merge
ren xconstfrompolity xconst


merge m:1 iso_d year using "wage40_f2_clean.dta"
drop _merge

*Set the sample
reg lncgdp_pc_f_adj mp_forg  avgyrs lnarabcap  xconst reg1-reg5 if year==1996 | year==2001 [aweight=pop2], r
gen robsamp=e(sample)
preserve
keep if robsamp==1

*Col. 1
reg lncgdp_pc_f_adj mp_forg  if year==1996 [aweight=pop2], r
*Col. 2
reg lncgdp_pc_f_adj mp_forg  avgyrs lnarabcap  xconst reg1-reg5 if year==1996 [aweight=pop2], r
*Col. 3
reg lncgdp_pc_f_adj mp  if year==1996 [aweight=pop2], r
*Col. 4
reg lncgdp_pc_f_adj mp  avgyrs lnarabcap xconst reg1-reg5 if year==1996 [aweight=pop2], r
*Col. 5
reg lncgdp_pc_f_adj mp_forg  if year==2001 [aweight=pop2], r
*Col. 6
reg lncgdp_pc_f_adj mp_forg  avgyrs lnarabcap xconst reg1-reg5 if year==2001 [aweight=pop2], r

*Col.7
reg lncgdp_pc_f_adj mp  if year==2001 [aweight=pop2], r
*Col. 8
reg lncgdp_pc_f_adj mp  avgyrs lnarabcap xconst reg1-reg5 if year==2001 [aweight=pop2], r

	
*Col. 9
xtreg lncgdp_pc_f_adj mp_forg  avgyrs lnarabcap  xconst i.year [aweight=pop2_ave], fe r cluster(id)

restore
drop robsamp


*WAGES
gen lnwage=ln(wage_monthly)
gen lnwage_adj= lnwage+cgdp_share_f2
reg lnwage_adj mp_forg  if year==2001 [aweight=pop2], r
reg lnwage_adj mp_forg  i.year [aweight=pop2], robust cluster(id)




*************
*Cleanup folder with miscellaneous files

rm inequality_wiid_2015.dta
rm gravity_06.dta
rm inequality_wiid_2015_o.dta
rm inequality_wiid_2015_d.dta
rm gravity_ineq_40.dta
rm penn_wt_2006.dta
rm penn_wt_2006_d.dta
rm penn_wt_2006_o.dta
rm yn_2006.dta


rm inequality_wiid_1996_o.dta
rm inequality_wiid_1996_d.dta
rm gravity_ineq_40_1996.dta
rm consumption_total_1996.dta
rm penn_wt_1996.dta
rm gravity_96.dta
rm beta_wt_1996.dta
rm beta_1996.dta
rm beta_1996_ces.dta
rm income_beta_1996.dta
rm beta_1996tran.dta
rm rgdp_pc.dta

rm inequality_wiid_2001_o.dta
rm inequality_wiid_2001_d.dta
rm gravity_ineq_40_2001.dta
rm consumption_total_2001.dta
rm penn_wt_2001.dta
rm gravity_01.dta
rm beta_2001.dta
rm beta_wt_2001.dta
rm beta_2001tran.dta
rm beta_2001_ces.dta
rm income_beta_2001.dta


rm income_beta_2006.dta
rm beta_2006_ces.dta
rm beta_2006tran.dta
rm beta_wt_2006.dta
rm beta_2006.dta

rm inequality_wiid_2011_o.dta
rm inequality_wiid_2011_d.dta
rm gravity_ineq_40_2011.dta
rm consumption_total_2011.dta
rm penn_wt_2011.dta
rm gravity_11.dta
rm beta_2011.dta
rm beta_2011tran.dta
rm beta_2011_ces.dta
rm beta_wt_2011.dta
rm income_beta_2011.dta
rm beta_dif_all.dta

rm income_beta.dta


rm MP_panel_all.dta

rm ctry_data_pop.dta
rm pop2011.dta


rm consumption_total.dta
rm omiga_total.dta
rm country_variables.dta

rm MP_panel.dta














	
	














